package cofh.thermal.expansion.block.entity.dynamo;

package .var.folders._j.vfbv187d0bb8b8w5spzgg8180000gn.T;

import cofh.core.client.renderer.model.ModelUtils;
import cofh.core.network.packet.client.TileStatePacket;
import cofh.core.util.helpers.FluidHelper;
import cofh.lib.api.StorageGroup;
import cofh.lib.api.block.entity.IPacketHandlerTile;
import cofh.lib.fluid.FluidStorageCoFH;
import cofh.thermal.core.config.ThermalCoreConfig;
import cofh.thermal.core.util.managers.dynamo.CompressionFuelManager;
import cofh.thermal.expansion.init.TExpTileEntities;
import cofh.thermal.expansion.inventory.container.dynamo.DynamoCompressionContainer;
import cofh.thermal.lib.block.entity.DynamoBlockEntity;
import javax.annotation.Nonnull;
import javax.annotation.Nullable;
import net.minecraft.core.BlockPos;
import net.minecraft.world.entity.player.Inventory;
import net.minecraft.world.entity.player.Player;
import net.minecraft.world.inventory.AbstractContainerMenu;
import net.minecraft.world.level.block.entity.BlockEntityType;
import net.minecraft.world.level.block.state.BlockState;
import net.minecraft.world.level.material.Fluid;
import net.minecraft.world.level.material.Fluids;
import net.minecraftforge.client.model.data.IModelData;
import net.minecraftforge.client.model.data.ModelDataMap;
import net.minecraftforge.fluids.FluidStack;

public class DynamoCompressionTile extends DynamoBlockEntity {
  protected FluidStorageCoFH fuelTank;
  
  public DynamoCompressionTile(BlockPos pos, BlockState state) {
    super((BlockEntityType)TExpTileEntities.DYNAMO_COMPRESSION_TILE.get(), pos, state);
    this.fuelTank = new FluidStorageCoFH(4000, fluid -> (this.filter.valid(fluid) && CompressionFuelManager.instance().validFuel(fluid)));
    this.tankInv.addTank(this.fuelTank, StorageGroup.INPUT);
    this.renderFluid = new FluidStack((Fluid)Fluids.f_76193_, 1000);
    addAugmentSlots(ThermalCoreConfig.dynamoAugments);
    initHandlers();
  }
  
  protected int getBaseProcessTick() {
    return CompressionFuelManager.instance().getBasePower();
  }
  
  protected boolean canProcessStart() {
    return (CompressionFuelManager.instance().getEnergy(this.fuelTank.getFluidStack()) > 0 && this.fuelTank.getAmount() >= 100);
  }
  
  protected void processStart() {
    if (cacheRenderFluid())
      TileStatePacket.sendToClient((IPacketHandlerTile)this); 
    this.fuel += this.fuelMax = Math.round(CompressionFuelManager.instance().getEnergy(this.fuelTank.getFluidStack()) * this.energyMod);
    this.fuelTank.modify(-100);
  }
  
  protected boolean cacheRenderFluid() {
    FluidStack prevFluid = this.renderFluid;
    this.renderFluid = new FluidStack(this.fuelTank.getFluidStack(), 1000);
    return !FluidHelper.fluidsEqual(this.renderFluid, prevFluid);
  }
  
  @Nullable
  public AbstractContainerMenu m_7208_(int i, Inventory inventory, Player player) {
    return (AbstractContainerMenu)new DynamoCompressionContainer(i, this.f_58857_, this.f_58858_, inventory, player);
  }
  
  @Nonnull
  public IModelData getModelData() {
    return (IModelData)(new ModelDataMap.Builder())
      .withInitial(ModelUtils.FLUID, this.renderFluid)
      .build();
  }
}
